#define UNICODE
#define _UNICODE

#include "sciter-win-main.cpp"
#include "resources.cpp"

#include <iostream>
#include <fstream>
#include <string>

using namespace std;

static RECT wrc = { GetSystemMetrics(SM_CXSCREEN)/2-600,
                    GetSystemMetrics(SM_CYSCREEN)/2-300,
                    GetSystemMetrics(SM_CXSCREEN)/2+600,
                    GetSystemMetrics(SM_CYSCREEN)/2+300
                  };




class frame: public sciter::window
{
public:
    frame() : window(SW_TITLEBAR | SW_RESIZEABLE | SW_CONTROLS | SW_MAIN | SW_ENABLE_DEBUG, wrc) {}

    std::vector<int> someFunc(const sciter::value vec)
    {

        cout << "Function someFunc called" << endl;

        std::vector<int> tempArr (3);

        for (int i=0; i<3; i++)
        {
            tempArr[i]=i*100;
        }

        int32_t firstVal=vec[0].get<uint32_t> ( );
        int32_t secondVal=vec[1].get<uint32_t> ( );
        int32_t thirdVal=vec[2].get<uint32_t> ( );
        cout << "Data from index.html script: someArr[0] is " << firstVal << endl;
        cout << "Data from index.html script: someArr[1] is " << secondVal << endl;
        cout << "Data from index.html script: someArr[2] is " << thirdVal << endl;
        return tempArr;

    }



    SOM_PASSPORT_BEGIN_EX(assetInterface, frame)
    SOM_FUNCS(
        SOM_FUNC(someFunc)
    )

    SOM_PASSPORT_END


};




LPCWSTR GetUrl()
{
    static WCHAR url[MAX_PATH] = {0};

    wcscpy(url,L"file://");
    GetModuleFileName(NULL,url+7,MAX_PATH-7);
    WCHAR* t = wcsrchr(url,'\\');
    assert(t);
    wcscpy(t + 1,L"..\\..\\resources\\index.html");
    return url;
}

int uimain(std::function<int()> run )
{

    SciterSetOption(NULL, SCITER_SET_DEBUG_MODE, TRUE);

    sciter::debug_output_console console; // console.log() ->  console window
    frame *pwin = new frame();

    //pwin->load( GetUrl());

    sciter::archive::instance().open(aux::elements_of(resources));
    pwin->load( WSTR("this://app/index.html") );

    pwin->expand();



    return run();
}


